
def zero (value, position):
  '''
  La funzione zero (valor, position) crea le righe della matrice
  di cui poi si servirà la comprehension successiva.
  
  value = dimensione della matrice
  position = posizione in cui si trova il valore uguale a 1
  
  Torna una riga alla volta
  '''
  
  # Istituisco alcune variabili d'utilità
  matrix = []
  i = 0
  
  
  while i < value:	# Finchè i è minore della dimensione massima della matrice...
    if i == position:	#... se l'indice corrisponde all'iterazione...
      matrix.append (1)	#... scrivo 1 perchè mi trovo sulla diagonale maggiore.
    else:
      matrix.append (0)	#... sennò scrivo 0, perchè NON mi trovo sulla diagonale maggiore
    i = i + 1
  
  return matrix

#**********************************************************************************************  
  
def square_matrix (value, elem):
  '''
  La funzione square_matrix (value, elem) costruisce riga per riga una
  matrice quadrata all'interno della quale sono elencati tutti i numeri fino 
  a n*n dove n è la dimensione della matrice.
  
  value = dimensione della matrice
  elem = elemento corrente
  
  Torna una riga della matrice alla volta
  '''
  # Definizione e inizializzazione di alcuni valori utili
  i = 1
  j = 0
  row = []
  
  # Definisco matrix con una comprehension per le liste: contiene tutti gli elem. da 0 a n*n
  matrix = [elem for elem in range (value**2)]
  while i <= value:					# Attraverso un ciclo inserisco riga per riga
    row = matrix[0 + (i * elem):value + (i * elem)]	# la lista precedente all'interno di un'altra lista creando così
    i = i + 1						# tramite una comprehension una matrice come da definizione

  return row
  
#**********************************************************************************************  

def trans_part (matrix, elem):
  '''
  La funzione trans_part (matrix, elem) crea riga per riga la matrice trasposta.
  
  matrix = la matrice la trasporre
  elem = l'elemento da iterare
  
  Torna una riga alla volta la matrice trasposta
  '''
  # Inizializzo alcune variabili utili
  i = 0
  j = 0
  row = []
  len_elem = len (matrix[0])
  
  # Elemento per elemento creo una trasposta della matrice d'entrata
  while i < len (matrix):
    row.append (matrix[i][elem])
    i = i + 1

  return row

#**********************************************************************************************  
  
def trans (matrix):
  '''
  La funzione trans (matrix) completa la trasformazione della matrice.
  
  matrix = la matrice da trasporre
  
  Torna la matrice trasposta
  '''
  # Attraverso una comprehension e l'invocazione della funzione trans_part (matrix, elem) creo una matrice trasposta
  trans_matrix = [trans_part (matrix, elem) for elem in range (len (matrix[0]))]
  
  return trans_matrix
  
#**********************************************************************************************

def dummy_sum (values):
  '''
  La funzione dummy_sum (value) prende in ingresso una lista di coppie di valori e
  fa la somma tra i valori di queste coppie, tornano una lista contenente i risultati
  
  values = lista di coppie di valori
  
  Torna una lista di valori
  '''
  # Inizializzazione variabili
  dummy_list = []
  dummy_val = 0
  
  for i in range (len (values)):		# Per tutta la lunghezza della lista di coppie...
    for j in range (len (values[i])):		# ... e per tutta la lunghezza delle coppie in questione...
      dummy_val = dummy_val + values[i][j]	# ... faccio una somma dei valori delle coppie.
    dummy_list.append(dummy_val)		# Il risultato lo immagazzino nella lista di ritorno della funzione
    dummy_val = 0				# Ovviamente ad ogni iterazione azzero la variabile di stoccaggio delle somme!
 
  return dummy_list
  
#**********************************************************************************************
  
def multiplicate (matrix_1, matrix_2, elem):
  '''
  La funzione moltiplicate (matrix_1, matrix_2, elem) moltiplica due matrici tra loro.
  Fa una certa quantità di lavoro sporco
  
  Torna una matrice moltiplicazione
  '''
  # Inizializzazione di alcune variabili
  i = 0
  j = 0
  val = 0
  k = 0
  row = []
  temp = []
  
  
  if len (matrix_1) < len (matrix_2):				# SE la matrix_1 ha meno righe della seconda...
    mat = matrix_2						# ... [def. variabile d'utilità]
    diff = len(matrix_2) - len (matrix_1)			# Definisco la differenza di lunghezza delle due matrici
    for j in range (len (matrix_1) + diff):			# Per tutta la lunghezza della matrice più piccola + la differenza...
      for i in range (len (matrix_2)):				# ... per tutta la lunghezza della seconda matrice...
        row.append (matrix_1[elem][i] * matrix_2[i][j])	# ... moltiplico ogni riga della prima per ogni colonna della seconda.
  else:								# SENNO'
    mat = matrix_1
    for j in range (len (matrix_1)):				# Faccio come prima senza tenere in considerazione la differenza
      for i in range (len (matrix_2)):				# delle lunghezze tra le matrici
        row.append (matrix_1[elem][i] * matrix_2[i][j])
     
  # Ora organizzo in gruppi i risultati delle moltiplicazioni precedenti in modo da creare una lista di sottoliste dove
  # ogni sottolista presenta gli addendi che andranno a determinare il risultato del valore nella matrice finale
  i = 0
  while i < len (mat):
    temp.append (row[0 + val:len (matrix_2) + val])
    val = val + len (matrix_2)
    i = i + 1

  # E passo tutto alla funzione dummy_sum (lista) che farà una "stupida" somma di ogni gruppo di valori
  row = dummy_sum (temp)
  
  return row
  
#**********************************************************************************************
  
def mul_matrix (matrix_1, matrix_2):
  '''
  La funzione mul_matrix (matrix_1, matrix_2) moltiplica due matrici e ne torna il risultato
  '''
  # Attraverso una comprehension creeremo una matrice moltiplicazione delle due in entrata 
  mul_part = [multiplicate (matrix_1, matrix_2, elem) for elem in range (len (matrix_1))]
  
  return mul_part
  

#**********************************************************************************************  

if __name__=='__main__':
  
  # Usare una comprehension per descrivere una matrice identità di dimensione fissata con tutti 1 sulla diagonale e 0 altrove
  dimensione = 6
  matrice = [zero (dimensione, elem) for elem in range (dimensione)]
  
  i = 0
  print ('\n*** Richiesta #1 ***')
  print ('Matrice identità = ')
  while i < len (matrice):
    print ('{0}'.format (matrice[i]))
    i = i + 1
  
  
  # Descrivere una matrice quadrata riempita con i primi n*n interi usando una comprehension
  dimensione = 7
  matrice_quadrata = [square_matrix (dimensione, elem) for elem in range (dimensione)]
  
  i = 0
  print ('\n*** Richiesta #2 ***')
  print ('Matrice quadrata dei primi n * n numeri = ')
  while i < len (matrice_quadrata):
    print ('{0}'.format (matrice_quadrata[i]))
    i = i + 1
  
  # Scrivere una funzione per trasporre una matrice generica indipendentemente dalla dimensione e dal contenuto
  # Trasporre = la prima riga diventa la prima colonna, etc.
  matrix = [[0, 1], [5, 3], [9, 0], [4, 8]]
  
  i = 0
  print ('\n*** Richiesta #3 ***')
  print ('Matrice di partenza = ')
  while i < len (matrix):
    print ('{0}'.format (matrix[i]))
    i = i + 1
  
  i = 0
  trans_matrix = trans (matrix)
  print ('Matrice trasposta = ')
  while i < len (trans_matrix):
    print ('{0}'.format (trans_matrix[i]))
    i = i + 1
  
  # Scrivere una funzione per moltiplicare due matrici non necessariamente quadrate
  matrix_1 = [[0, 1], [5, 3], [9, 0], [4, 8]]
  matrix_2 = [[3, 5, 2, 0], [9, 0, 1, 2]]
  
  mul = mul_matrix (matrix_1, matrix_2)
  
  i = 0
  print ('\n*** Richiesta #4 (prova #1) ***')
  print ('Moltiplicazione tra le due matrici = ')
  while i < len (mul):
    print ('{0}'.format (mul[i]))
    i = i + 1
    
  matrix_1 = [[1, 1, 2], [0, 1, -3]]
  matrix_2 = [[1, 1, 1], [2, 5, 1], [0, -2, 1]]
  
  mul = mul_matrix (matrix_1, matrix_2)
  
  i = 0
  print ('\n*** Richiesta #4 (prova #2)***')
  print ('Moltiplicazione tra le due matrici = ')
  while i < len (mul):
    print ('{0}'.format (mul[i]))
    i = i + 1
  
  
  