import sys, os, stat

'''
Implementare il comando CAT: data una lista di file stampa nel terminale
il loro contenuto
'''

def cat (lista_file):
  '''
  La funzione cat (lista_file) prende in ingresso una lista contenente i nomi di alcuni file e
  stampa nel terminale TUTTO il loro contenuto.
  
  lista_file = lista di nomi di file
  '''
  
  for i in range (len (lista_file)):
    if os.path.isfile (lista_file[i]) == False:
      print ('"{0}" non è un file.'.format (lista_file[i]))
    else:
      miofile = open (lista_file[i], 'r')
      if miofile == False:
        raise IOError ('Impossibile aprire il file.')
      else:
        print ('\n\n************************************\nContenuto del file "{0}":\n'.format (lista_file[i]))
        print (miofile.read())
    miofile.close()
  
  return

'''
Implementare il comando CHMOD: un comando che permette di cambiare
le modalità di accesso ad un dato gruppo di file
'''

modes = {'r': (stat.S_IRUSR, stat.S_IRGRP, stat.S_IROTH), 
         'w': (stat.S_IWUSR, stat.S_IWGRP, stat.S_IWOTH),
         'x': (stat.S_IXUSR, stat.S_IXGRP, stat.S_IXOTH)}
def format_mode (mode):
  
  s = 'd' if stat.S_ISDIR(mode) else "-"
  for i in range (3):
    for j in ['r', 'w', 'x']:
      s += j if stat.S_IMODE(mode) & modes [j][i] else '-'
      
  return s

def chmod (lista_file, mode):
  '''
  La funzione chmod (lista_file) cambia le modalità d'accesso ad un dato gruppo di
  file in entrata.
  
  lista_file = lista di file
  mode = modalità di accesso da sovrascrivere
  '''
  
  for i in range (len (lista_file)):
    metadata = os.stat (lista_file[i])
    print ('PRIMA = {1} {0}'.format (lista_file[i],format_mode (metadata.st_mode)))
    os.chmod (lista_file[i], mode)
    metadata = os.stat (lista_file[i])
    print ('DOPO  = {1} {0}\n*****************************'.format (lista_file[i],format_mode (metadata.st_mode)))
  
  
  return

'''
Implementare il comando MORE: un comando che stampa il contenuto
di un file 30 righe alla volta ed attraverso un input da tastiera
stampa le successive 30
'''

def more (lista_file, limite):
  '''
  La funzione more (lista_file) stampa il contenuto di una lista di file 30
  righe alla volta. Passa alle 30 righe successive tramite un input da tastiera.
  
  lista_file = lista di file in ingresso
  limite = massimo numero di righe da stampare
  '''
  
  segnalibro = 0
  
  for i in range (len (lista_file)):
    if os.path.isfile (lista_file[i]) == False:
      print ('"{0}" non è un file.'.format (lista_file[i]))
    else:
      miofile = open (lista_file[i], 'r')
      if miofile == False:
        raise IOError ('Impossibile aprire il file.')
      else:
        print ('\n\n************************************\nContenuto del file "{0}":\n'.format (lista_file[i]))
        righe = miofile.readlines()

        value = len (righe) / limite
        if value > len (righe) // limite:
          value += 1
        
        for k in range (int (value)):
          for j in range (limite):
            try:
              print ('{0} - {1}'.format (j + segnalibro + 1, righe[j + segnalibro]))
            except IndexError:
              exit()
          input()
          segnalibro += limite
    miofile.close()
  
  
  return


if __name__ == '__main__':
  
  # Passo a riga di comando il nome del file
  nomi_file = []
  
  for i in range (len (sys.argv)):
    if i >= 1:
      nomi_file.append (sys.argv[i])
  
  '''
  S_IRUSR = il proprietario ha permesso di scrittura
  S_IWUSR = il proprietario ha permesso di lettura
  S_IXUSR = il proprietario ha permesso di esecuzione
  Default = 33204
  '''
  
  chmod (nomi_file, 33204)
  
  cat (nomi_file)
  
  more (nomi_file, 30)
  
  