
import math
import functools

# ****************************************************************
def mul_of_3_or_5 (x):
  return (x%3 == 0) or (x%5 == 0)
  
def sum_all_numbers (x, y):
  return (x + y)
  
# ****************************************************************

def MCD (a, b):
  ''' Massimo Comun Divisore '''
  if a < b:
    temp = a
    a = b
    b = temp
  
  quo = a // b
  res = a % b
  
  if res != 0:
    return MCD (b, res)
  else:
    return b
    
def MCM (a, b):
  ''' Minimo Comune Multiplo '''
  return (a * b) // MCD (a, b)
  
def general_MCM (a):
  ''' Minimo Comune Multiplo Generalizzato per una serie di numeri (e non solo per due) '''
  if a > 2:
    i = 3
    store = MCM (1,2)
    while i <= a:
      store = MCM (store, i)
      i += 1
    return store
  else:
    return MCM (1,2)
  
  
# ****************************************************************

def fibo (a):
  ''' Sequenza di Fibonacci '''
  if a <= 1:
    return a
  else:
    return fibo (a - 1) + fibo (a - 2)
    
    

if __name__=='__main__':
  
  # Sum all the natural numbers below one thousand that are multiples of 3 or 5.
  numeri_divisi_da_3_e_5 = list (filter (mul_of_3_or_5, range (1, 1000)))
  print ('\nSomma di tutti i valori da 1 a 1000 divisibili per 3 e per 5 = {0}'.format (functools.reduce (sum_all_numbers, numeri_divisi_da_3_e_5)))
  
  # Calculate the smallest number divisible by each of the numbers 1 to 20. (Minimo Comune Multiplo)
  #print (list (filter (divisible, range (1, 232792560))))
  print ('Il minimo valore che può essere diviso da tutti i numeri da 1 a 20 è {0}'. format (general_MCM (20)))
  
  
  # Calculate the sum of digit of the number 2^1000
  number = str(2**1000)
  i = 0
  sum_all_numbers = 0
  for i in range (len (number)):
    sum_all_numbers += int (number[i])
    
  print ('Somma di tutte le cifre di 2^1000 = {0}'.format (sum_all_numbers))
  
  # Calculate the first term in the Fibonacci sequence to contain 1000 digits.
  n = 0
  while len (str (fibo (n))) <= 4:
    if len (str (fibo(n))) == 4:
      print ('Il primo numero della sequenza di Fibonacci con 4 cifre è {0}.\n'.format (fibo(n)))
      break
    n += 1
  