import os, sys, re

'''
Let's write a module (a pool of functions) that given a quite large text 
(over than 2000 words) counts how frequent each word occurs in the text.

The text is read from a file and it is a real text with punctuation 
(i.e., commas, semicolons, ...) that should be counted.

Note: that words with different case should be considered the same.

******************
Faccio largo utilizzo delle Regular Expression (RE) perchè secondo me è 
così che vorrebbe il profe. Sono moooolto utili, una volta capito come
si usano!!
******************

Per far 'funzionare' tutto si deve scrivere a riga di comando:
>> python3 Esercizio2.py NOMEFILE PAROLA1 PAROLA2 ecc
Esempio:
>> python3 Esercizio2.py Testo.txt ciao mamma salame botta sole
'''

def text_machine (nome_file, parole):
  
  file_split = []
  
  if os.path.isfile (nome_file) == False:
    print ('\nATTENZIONE: "{0}" non è un file valido.\n'.format (nome_file))
  else:
    miofile = open (nome_file, 'r')
    if miofile == False:
      raise IOError ('\nImpossibile aprire il file "{0}"!!\n'.format (nome_file))
    else:
      file_letto = miofile.read()
      file_split = file_letto.split(' ')
      pattern = re.compile (r'\b[a-zA-Z0-9](.|,|:|;|\b)')
      
      print ('\n"{0}" contiene:'.format (nome_file))
      print (':: {0} punti fermi (.)'.format (file_letto.count('.')))
      print (':: {0} virgole (,)'.format (file_letto.count(',')))
      print (':: {0} punti e virgole (;)'.format (file_letto.count(';')))
      print (':: {0} accapo (\\n)'.format (file_letto.count('\n')))
      print (':: {0} parole'.format (len (pattern.findall (file_letto))))
      if parole != []:
        for i in range (len (parole)):
          parole[i] = parole[i].lower()
          pattern1 = re.compile (r'\b{0}(.|,|:|;|\b)'.format (parole[i]))
          pattern2 = re.compile (r'\b{0}(.|,|:|;|\b)'.format (parole[i].capitalize()))
          occorrenza_parole = len (pattern1.findall (file_letto)) + len (pattern2.findall (file_letto))
          print (':: La parola \'{0}\' compare {1} volte nel testo ({2} volte nella forma di \'{3}\' + {4} volte nella forma di \'{5}\').'.format (parole[i], occorrenza_parole, len (pattern1.findall (file_letto)), parole[i], len (pattern2.findall (file_letto)), parole[i].capitalize()))
      print()
    miofile.close ()
  return


if __name__ == '__main__':
  
  nome_file = sys.argv[1]
  parole = sys.argv[2:len (sys.argv)]
  
  text_machine (nome_file, parole)