import math
'''
sin(x) can be approximate by the Taylor's series:

x - x^3/3! + x^5/5! ...

Let's write a library to implement sin(x, n) by 
using the Taylor's series (where n is the level 
of approximation, i.e., 1 only one item, 2 two 
items, 3 three items and so on).

Let's compare your function with the one implemented 
in the math module at the growing of the approximation level.

Hint. Use a generator for the factorial and a 
comprehension for the series.
'''

def fact_generator (x):
  while x > 0:
    yield x
    x = x - 1

def fact (x):
  '''
  fact (x) -- Funnzione che calcola il fattoriale di un numero.
  
  x = valore di cui calcolare il fattoriale
  '''
  if x == 1:
    return 1
  else:
    return x * fact (x - 1)

def sin (x, n):
  '''
  sin (x, n) -- La funzione calcola il seno di x approssimato
  servendosi della serie di Taylor.
  
  x = valore di cui calcolare il seno
  n = livello di approssimazione
  '''
  sin = 0
  series = [(pow (-1, n) / fact ((2 * n) + 1)) * pow (x, ((2 * n) + 1)) for n in range (n + 1)]
  for i in range (len (series)):
    sin += series [i]
  return sin


if __name__ == '__main__':
  
  x = 2
  n = 100
  print ()
  print ('Funzione sin (x, n) = {0}'.format (sin(x, n)))
  print ('Funzione math.sin (x) = {0}'.format (math.sin (x)))
  print ()
  
  for i in fact_generator (3):
    print (i)
  print ()
  