import unittest, Validate


class testValidate (unittest.TestCase):
  
  '''
  Ogni caso conserva:
  - la 'casistica' in una stringa
  - True se è una configurazione corretta, False altrimenti
  - True se comprende una configurazione vincente, False altrimenti
  - True se il quadro è completo, False altrimenti
  '''
  
  case_01 = ('xo x  oo ', True, False, False)
  case_02 = ('xo x  xo ', True, True, False)
  case_03 = ('xoax  oo ', True, False, False)
  case_04 = ('xoooxxoxo', True, False, True)
  
  list_of_test = [case_01, case_02, case_03, case_04]
  
  def test_true_configuration (self):
    for case, conf, win, full in self.list_of_test:
      result = Validate.validate (case)
      self.assertEqual (result[0], conf)

  def test_winner_configuration (self):
    for case, conf, win, full in self.list_of_test:
      result = Validate.validate (case)
      self.assertEqual (result[1], win)
      
  def test_full_configuration (self):
    for case, conf, win, full in self.list_of_test:
      result = Validate.validate (case)
      self.assertEqual (result[2], full)
      
if __name__ == '__main__':
  unittest.main ()