'''
A function validate that checks if a string composed of 'X', 'O' and ' ' 
is a correct configuration for the tic-tac-toe game and if it is a winning 
configuration for the 'X' or the 'O' symbols, an even configuration or 
if there are still moves.
'''

import re

def validate (matrix):
  
  pattern_configuration = [0, 0, 0]
  
  pattern_true_configuration = re.compile ('[xo ]')
  pattern_full_configuration = re.compile ('[ ]')
  
  # Test per controllare se la scacchiera è completa
  if re.findall (pattern_full_configuration, matrix):
    pattern_configuration[2] = False
  else:
    pattern_configuration[2] = True
  
  # Test per controllare se esiste una combinazione vincente
  if (matrix[0] == matrix[3] == matrix[6] != ' ') or (matrix[1] == matrix[4] == matrix[7] != ' ') or (matrix[2] == matrix[5] == matrix[8] != ' ') or (matrix[0] == matrix[1] == matrix[2] != ' ') or (matrix[3] == matrix[4] == matrix[5] != ' ') or (matrix[6] == matrix[7] == matrix[8] != ' ') or (matrix[0] == matrix[4] == matrix[8] != ' ') or (matrix[2] == matrix[4] == matrix[6] != ' '):
    pattern_configuration[1] = True
  else:
    pattern_configuration[1] = False
  
  # Test per controllare che si usino solo caratteri ammessi
  if re.findall (pattern_true_configuration, matrix):
    pattern_configuration[0] = True
  else:
    pattern_configuration[0] = False
    
  return pattern_configuration
  
