import unittest, SquareMatrix

def sum_in_row (matrix, size):
    
  row_sum = []
  local_sum = 0
    
  for lenght in range (size):
    row_sum.append (0)
    
  for row in range (size):
    for column in range (size):
      local_sum += matrix[row][column]
    row_sum[row] = local_sum
    local_sum = 0
    
  return row_sum

def transpose (matrix, size):
    
  temp_matrix = []
  temp_row = []
  for lenght in range (size):
    temp_matrix.append ([])
    
  for row in range (size):
    for column in range (size):
      temp_row.append (matrix[column][row])
    temp_matrix[row] = temp_row
    temp_row = []
    
  return temp_matrix


def make_testSquareMatrix (classMatrix, size, a_sum, a_transpose):
  class testSquareMatrix (unittest.TestCase):

    def setUp (self):
      self.known_sum_row = [(matrix_size, a_sum(classMatrix(matrix_size).matrix, matrix_size)) for matrix_size in range (1, size)]
      self.known_transpose = [(matrix_size, a_transpose(classMatrix(matrix_size).matrix, matrix_size)) for matrix_size in range (1, size)]
    
    def test_sum_in_row (self):
      '''Test sum_in_row for a matrix {0}x{0}'''.format (size)
      for matrix_size, sum_row in self.known_sum_row:
        result = classMatrix(matrix_size).sum_in_row()
        self.assertEqual (sum_row, result)
        
    def test_traspose (self):
      '''Test traspose for a matrix {0}x{0}'''.format (size)
      for matrix_size, transpose in self.known_transpose:
        result = classMatrix(matrix_size).transpose()
        self.assertEqual (transpose, result)
      
  return testSquareMatrix
  
  
  
if __name__ == '__main__':
  
  size = 5
  test = make_testSquareMatrix (SquareMatrix.squareMatrix, size, sum_in_row, transpose)

  unittest.main()