class logging:
  
  def __init__ (self, method):
    self.method = method
    self.storage = ''
    
  def __call__ (self, *args):
    message = '{0}({1})\n'.format (self.method.__name__, args[0])
    self.storage += message
    log = open ('filelog.txt', 'w')
    log.write (self.storage)
    
    
'''
def memorization (method):
  def true_decorator (*args):
    print ('{0}({1})'.format (method.__name__, args[1]))
    return method(*args)
    
  return true_decorator
'''
  
  
  
def stack_trace (cls):
  class true_decorator:
    
    stack_trace = []
    
    def __init__ (self, *args):
      self.new_instance = cls (*args)
      
    def __getattr__ (self, name):
      self.stack_trace.append ('{0}.{1}'.format (cls.__name__, name))
      return getattr (self.new_instance, name)
      
    def __setattr__ (self, attribute, value):
      if attribute == 'new_instance':
        self.__dict__[attribute] = value
      else:
        return setattr (self.new_instance, attribute, value)
    
    
  return true_decorator
  


@stack_trace
class myMath:
  
  def __init__ (self):
    object.__init__(self)
  
  #@logging
  def fib (self, value):
    if value <= 1:
      return value
    else:
      return self.fib (value - 1) + self.fib (value - 2)
      
  #@logging
  def fact (self, value):
    if value <= 1:
      return value
    else:
      return value * self.fact (value - 1)
      
  def derivative (f):
    def df (x, h=0.1e-5):
      return ( f(x+h/2) - f(x-h/2) )/h
    return df
  
  def taylor (self, f, n, a):
    taylor = 0
    series = [... for n in range (n + 1)]
    for i in range (len (series)):
      taylor += series [i]
    return taylor
    

if __name__ == '__main__':
  print ()
  math = myMath ()
  math.fact (5) 
  math.fact (6)
  math.fib (25)
  math.fact (7)
  math.fib (12)
  math.fib (5)
  #print (math.fact (3))
  #print (math.fib (5))
  #math.fact_value.append (1)
  #print (math.fact_value)
  # +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  '''
  print (':: math.fib')
  for fib in math.fib_value:
    print (fib)
  '''

  # +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  print ()
  count = 1
  print ('*STACK TRACE*')
  for every_call in math.stack_trace:
    print ('{0} :: {1}'.format (count, every_call))
    count += 1

  
  print ()