def counter_dec (method):
  count = 0
  def decorator (*args):
    nonlocal count
    count += 1
    print ('Num. Istanze... {0}'.format (count))
    return method (*args)
  return decorator
  

class counter (type):
  def __new__ (meta, classname, supers, classdict):
    for attr, attrval in classdict.items():
      if attr == '__init__':
        classdict[attr] = counter_dec(attrval)
    return type.__new__ (meta, classname, supers, classdict)
  
  def __init__ (cls, classname, supers, classdict):
    pass

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
def day_salary_count (obj):
  return obj.pay_for_hour * 8
  
def set_day_salary (obj, value):
  obj.pay_for_hour = value / 8
    
def week_salary_count (obj):
  return obj.day_salary_count() * 5
  
def set_week_salary (obj, value):
  obj.pay_for_hour = (value / 8) / 5
    
def month_salary_count (obj):
  return obj.week_salary_count () * 4
 
def set_month_salary (obj, value):
  obj.pay_for_hour = ((value / 8) / 5) / 4
  
def year_salary_count (obj):
  return obj.month_salary_count () * 12
    
def set_year_salary (obj, value):
  obj.pay_for_hour = (((value / 12) / 8) / 5) / 4
    
    
class spell (type):
  def __new__ (meta, classname, supers, classdict):
    classname = 'worker'
    classdict['pay_for_hour'] = 0
    classdict['set_day_salary'] = set_day_salary
    classdict['day_salary_count'] = day_salary_count
    classdict['set_week_salary'] = set_week_salary
    classdict['week_salary_count'] = week_salary_count
    classdict['set_month_salary'] = set_month_salary
    classdict['month_salary_count'] = month_salary_count
    classdict['set_year_salary'] = set_year_salary
    classdict['year_salary_count'] = year_salary_count
    return type.__new__(meta, classname, supers, classdict)
    
  def __init__ (cls, classname, supers, classdict):
    pass
  
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
def twice_called (method):
  time_call = 0
  def decorator (*args):
    nonlocal time_call
    time_call += 1
    if time_call == 2:
      time_call = 0
      return method (*args)
  return decorator


class multiTriggeredMethod (type):
  def __new__ (meta, classname, supers, classdict):
    for attr, attrval in classdict.items():
      if attr[0] != '_':
        if type(attrval).__name__ == 'function':
          classdict[attr] = twice_called (attrval)
    return type.__new__(meta, classname, supers, classdict)
    
  def __init__ (cls, classname, supers, classdict):
    pass


#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

class person (metaclass=multiTriggeredMethod):
  
  name = ''
  lastname = ''
  birthday = '00/00/0000'
  
  def __init__(self, name, lastname, birthday):
    self.name = name
    self.lastname = lastname
    self.birthday = birthday
    
  def i_am_dummy (self):
    print ('{0} è scemo!!'.format (self.name))
  
  def __repr__ (self):
    self.print_format = 'Name... {0}\nLastname... {1}\nBirthday... {2}'.format (self.name, self.lastname, self.birthday)
    return self.print_format
  
  
  
if __name__=='__main__':
  print ()
  sam = person ('Sam', 'Simpson', '19/03/1960')
  #sam.pay_for_hour = 3.4
  print (sam)
  #print ('Salario annuale di {0}... {1}'.format (sam.name, sam.year_salary_count()))
  print ('Classe di {0}... {1}'.format (sam.name, type (sam).__name__))
  print ()
  marco = person ('Marco', 'Rossi', '23/12/1989')
  print (marco)
  marco.i_am_dummy()
  marco.i_am_dummy()
  print ()
  